#ifndef __ADC_SPI_H__
#define __ADC_SPI_H__
#include "hardwareprofile.h"

#define ADC_CS      GPIO_NUM_17

typedef enum {
    ADC_CH_0 = 0,
    ADC_CH_1 = 1,
    ADC_CH_PRESS1 = 2,
    ADC_CH_PRESS2 = 3,
    ADC_CH_420MA1 = 4,
    ADC_CH_420MA2 = 5,
    ADC_CH_6 = 6,
    ADC_CH_7 = 7,
    ADC_CH_NUM = 8,
} adc_channel_t;

void init_adc(spi_device_handle_t *spi);

uint16_t get_adc_channel(spi_device_handle_t spi, adc_channel_t channel);
uint8_t adc_to_temp(uint16_t adc);
uint16_t ma420_to_adc(uint8_t ma);
uint8_t adc_to_420ma(uint16_t adc);
uint8_t adc_to_10v(uint16_t adc);
uint8_t adc_to_bar(uint16_t adc, uint16_t offset);

#endif
