/******************************************************************************/
/*                                                                            */
/*  HSW snc - Casalecchio di Reno (BO) ITALY                                  */
/*  ----------------------------------------                                  */
/*                                                                            */
/*  modulo: 24XX16.h                                                          */
/*                                                                            */
/*      gestione EEPROM 24XX16                                                */
/*                                                                            */
/*  Autore: Mattia Maldini e Massimo Zanna                                    */
/*                                                                            */
/*  Data  : 02/01/2017      REV  : 00.0                                       */
/*                                                                            */
/*  U.mod.: 04/01/2017      REV  : 15.0                                       */
/*                                                                            */
/******************************************************************************/

#ifndef __24XX16_H__
#define __24XX16_H__

#include <stdint.h>
#include "esp_err.h"
#include "driver/gpio.h"
#include "i2c_devices/i2c_driver.h"

#define BITMAP(x) (1ULL << (x))

#define HIGH_ADD_LIMIT 0x07
#define BLOCK_SIZE      0x100
#define PAGE_SIZE       0x10
#define EEPROM_SIZE        0x800 // 2 Kbyte

void init24XX16(gpio_num_t writeProtect);

esp_err_t byteWrite_24XX16(uint8_t ControlByte, uint8_t HighAdd, uint8_t LowAdd, uint8_t Data);
esp_err_t byteRead_24XX16(uint8_t ControlByte, uint8_t HighAdd, uint8_t LowAdd, uint8_t *Data);

esp_err_t sequentialWrite_24XX16(uint8_t ControlByte, uint8_t HighAdd, uint8_t LowAdd, uint8_t *wrptr, uint Length);
esp_err_t sequentialRead_24XX16(uint8_t ControlByte, uint8_t HighAdd, uint8_t LowAdd, uint8_t *rdptr, uint length);

esp_err_t test_eeprom();

#endif
