#ifndef __PCB_H__
#define __PCB_H__

#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "listx.h"

typedef struct _pcb {
    struct list_head p_next;
    unsigned long timestamp;
    TaskHandle_t task;
    int alarm;
    int todie;
    int safetodelete;

    void *args;
} pcb_t;

void init_process_list();
pcb_t *alloc_pcb(void *ptr);
void free_pcb(pcb_t *p);
pcb_t *out_procq(struct list_head *q, pcb_t *p);
void insert_procq(struct list_head *q, pcb_t *p);
pcb_t *remove_procq(struct list_head *q);
#endif
