#include <stdint.h>
#include <string.h>
#include "esp_log.h"
#include "i2c_devices/24XX16.h"
#include "hardwareprofile.h"

#define BUFFER_SIZE 1024


esp_err_t test_eeprom() {
    esp_err_t ret;
    uint8_t   buffer[BUFFER_SIZE];
    int       i;

    for (i = 0; i < BUFFER_SIZE; i++) {
        buffer[i] = (uint8_t)i % 256;
    }

    ret = sequentialWrite_24XX16(EEPROM_ADD, 0x00, 0x00, buffer, BUFFER_SIZE);
    if (ret != ESP_OK)
        return ret;

    memset(buffer, 0, BUFFER_SIZE);

    ret = sequentialRead_24XX16(EEPROM_ADD, 0x00, 0x00, buffer, BUFFER_SIZE);
    if (ret != ESP_OK)
        return ret;

    for (i = 0; i < BUFFER_SIZE; i++) {
        if (buffer[i] != (uint8_t)i % 256) {
            printf("expected %d, found %d at position %i\n", (uint8_t)i % 256, buffer[i], i);
            return ESP_FAIL;
        }
    }

    printf("test eeprom check [x]");

    return ESP_OK;
}
