#include "hardwareprofile.h"
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "freertos/timers.h"
#include "driver/gpio.h"

static xTaskHandle suspendingTask;

void task_suspend_core(void *args) {
    vTaskSuspendAll();
    xTaskNotifyWait(0,0,0, portMAX_DELAY);
    xTaskResumeAll();
    vTaskDelete(NULL);
}

void absoluteSuspendAll() {
    int core = xPortGetCoreID();
    //vTaskSuspendAll();
    xTaskCreatePinnedToCore(task_suspend_core, "idle", 2048, NULL, configMAX_PRIORITIES-1, &suspendingTask, 1-core);
    vTaskDelay(1);
}

void absoluteResumeAll() {
    xTaskNotifyGive(suspendingTask);
    //xTaskResumeAll();
}